Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## oracle.ifs.server
Class IfsConnectionPool

    java.lang.Object
      oracle.ifs.server.IfsConnectionPool

All Implemented Interfaces:
  ConnectionPool, SubService

Direct Known Subclasses:
  TieIfsConnectionPool

    public class IfsConnectionPool

extends java.lang.Object
implements ConnectionPool

A IfsConnectionPool is the native imlementation of ConnectionPool, which is a dynamically-sized pool of LibraryConnections.

(Unpublished)

Field Summary
`protected int` | `m_ConnectionPurgeAttempts` The number of times one of the LibraryConnections performed a statement purge attempt as part of being allocated.
`protected int` | `m_ConnectionStatementPurgeCount` The number of statements purged by LibraryConnections during purges that occur as part of being allocated.
`protected javax.sql.DataSource` | `m_DataSource` Database connection factory used to make connections to the database schema.
`protected int` | `m_DefaultRowPrefetch` The default number of prefetched rows.
`protected int` | `m_DeferredAllocationCount` The number of connection allocation requests that were serviced after wating for an existing LibraryConnection to become available, either by allocating an existing LibraryConnection (if possible) or by creating a new LibraryConnection.
`protected int` | `m_FailedAllocationCount` The number of connection allocation requests that failed (throwing an exception) because no existing LibraryConnection became available within `m_MaximumSizeTimeout` milliseconds and no new LibraryConnection could be created because the ConnectionPool size had reached its absolute maximum.
`protected int` | `m_ImmediateAllocationCount` The number of connection allocation requests that were serviced immediately, either by allocating an existing LibraryConnection (if possible) or by creating a new LibraryConnection.
`protected java.io.PrintStream` | `m_JdbcLogStream` The PrintStream to which the JDBC log will be sent, or null to disable JDBC logging.
`protected int` | `m_MaximumSize` The absolute maximum number of LibraryConnections in this ConnectionPool.
`protected long` | `m_MaximumSizeTimeout` The period of time, in milliseconds, that attempting to acquire a LibraryConnection will wait before throwing an exception if the ConnectionPool size has reached its absolute maximum.
`protected int` | `m_MinimumSize` The minimum number of LibraryConnections in this ConnectionPool.
`protected java.lang.String` | `m_Name` The name of the ConnectionPool.
`protected S_LibraryService` | `m_Service` The S_LibraryService that created this ConnectionPool.
`protected int` | `m_StatementCacheSizeTrigger` The number of statements that need to be cached before a purge is triggered.
`protected int` | `m_StatementCacheTarget` The target maximum number of statements we wish to keep cached.
`protected int` | `m_StatementResetLimit` Access limit at which statements saved in LibraryConnections will be closed and re-opened.
`protected int` | `m_TargetSize` The target maximum number of LibraryConnections in this ConnectionPool.
`protected long` | `m_TargetSizeTimeout` The period of time, in milliseconds, that attempting to acquire a LibraryConnection will wait before creating a new LibraryConnection if the ConnectionPool size has reached its target maximum.
`protected long` | `m_TotalAllocationTime` The average elapsed time for a successful allocation request, in milliseconds.

Constructor Summary
`IfsConnectionPool()` Constructs an uninitialized IfsConnectionPool.

Method Summary
`LibraryConnection` | `acquireLibraryConnection()` Gets a LibraryConnection from this ConnectionPool.
`protected void` | `createLibraryConnection()` Creates a new LibraryConnection and adds it to this ConnectionPool.
`void` | `dispose()` Shuts down this ConnectionPool.
`void` | `dispose(boolean force)` Shuts down this ConnectionPool.
`ConnectionPoolConfiguration` | `getConnectionPoolConfiguration()` Gets the configuration parameters of this ConnectionPool.
`ConnectionPoolPerformance` | `getConnectionPoolPerformance()` Gets the performance information for this ConnectionPool.
`void` | `initialize(S_LibraryService service, ConnectionPoolConfiguration configuration)` Initializes an IfsConnectionPool.
`void` | `releaseLibraryConnection(LibraryConnection lconn)` Releases the specified LibraryConnection back to this ConnectionPool.
`void` | `resetCachedStatements()` Resets the cached statements in all LibraryConnections.
`void` | `resetStatistics()` Resets the performance statistics of this ConnectionPool.
`void` | `setConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)` Alters the configuration of this ConnectionPool.
`protected void` | `validateConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)` validate connection pool configuration.
`void` | `validateUnallocatedConnections()` Validates the unallocated connections.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### m_Service

    protected S_LibraryService m_Service

  Description copied from class: `IfsConnectionPool`
  The S_LibraryService that created this ConnectionPool.

### m_Name

    protected java.lang.String m_Name

  Description copied from class: `IfsConnectionPool`
  The name of the ConnectionPool.

### m_DataSource

    protected javax.sql.DataSource m_DataSource

  Description copied from class: `IfsConnectionPool`
  Database connection factory used to make connections to the database schema.

### m_JdbcLogStream

    protected java.io.PrintStream m_JdbcLogStream

  Description copied from class: `IfsConnectionPool`
  The PrintStream to which the JDBC log will be sent, or null to disable JDBC logging.

### m_DefaultRowPrefetch

    protected int m_DefaultRowPrefetch

  Description copied from class: `IfsConnectionPool`
  The default number of prefetched rows.

### m_StatementResetLimit

    protected int m_StatementResetLimit

  Description copied from class: `IfsConnectionPool`
  Access limit at which statements saved in LibraryConnections will be closed and re-opened.

### m_StatementCacheTarget

    protected int m_StatementCacheTarget

  Description copied from class: `IfsConnectionPool`
  The target maximum number of statements we wish to keep cached.

### m_StatementCacheSizeTrigger

    protected int m_StatementCacheSizeTrigger

  Description copied from class: `IfsConnectionPool`
  The number of statements that need to be cached before a purge is triggered.

### m_MinimumSize

    protected int m_MinimumSize

  Description copied from class: `IfsConnectionPool`
  The minimum number of LibraryConnections in this ConnectionPool.

### m_TargetSize

    protected int m_TargetSize

  Description copied from class: `IfsConnectionPool`
  The target maximum number of LibraryConnections in this ConnectionPool.

### m_MaximumSize

    protected int m_MaximumSize

  Description copied from class: `IfsConnectionPool`
  The absolute maximum number of LibraryConnections in this ConnectionPool.

### m_TargetSizeTimeout

    protected long m_TargetSizeTimeout

  Description copied from class: `IfsConnectionPool`
  The period of time, in milliseconds, that attempting to acquire a LibraryConnection will wait before creating a new LibraryConnection if the ConnectionPool size has reached its target maximum.

### m_MaximumSizeTimeout

    protected long m_MaximumSizeTimeout

  Description copied from class: `IfsConnectionPool`
  The period of time, in milliseconds, that attempting to acquire a LibraryConnection will wait before throwing an exception if the ConnectionPool size has reached its absolute maximum.

### m_ImmediateAllocationCount

    protected int m_ImmediateAllocationCount

  Description copied from class: `IfsConnectionPool`
  The number of connection allocation requests that were serviced immediately, either by allocating an existing LibraryConnection (if possible) or by creating a new LibraryConnection.

### m_DeferredAllocationCount

    protected int m_DeferredAllocationCount

  Description copied from class: `IfsConnectionPool`
  The number of connection allocation requests that were serviced after wating for an existing LibraryConnection to become available, either by allocating an existing LibraryConnection (if possible) or by creating a new LibraryConnection.

### m_FailedAllocationCount

    protected int m_FailedAllocationCount

  Description copied from class: `IfsConnectionPool`
  The number of connection allocation requests that failed (throwing an exception) because no existing LibraryConnection became available within `m_MaximumSizeTimeout` milliseconds and no new LibraryConnection could be created because the ConnectionPool size had reached its absolute maximum.

### m_ConnectionPurgeAttempts

    protected int m_ConnectionPurgeAttempts

  Description copied from class: `IfsConnectionPool`
  The number of times one of the LibraryConnections performed a statement purge attempt as part of being allocated.

### m_ConnectionStatementPurgeCount

    protected int m_ConnectionStatementPurgeCount

  Description copied from class: `IfsConnectionPool`
  The number of statements purged by LibraryConnections during purges that occur as part of being allocated.

### m_TotalAllocationTime

    protected long m_TotalAllocationTime

  Description copied from class: `IfsConnectionPool`
  The average elapsed time for a successful allocation request, in milliseconds.

Constructor Detail

### IfsConnectionPool

    public IfsConnectionPool()

  Constructs an uninitialized IfsConnectionPool.

Method Detail

### initialize

    public void initialize(S_LibraryService service,
                           ConnectionPoolConfiguration configuration)
                    throws IfsException

  Description copied from class: `IfsConnectionPool`
  Initializes an IfsConnectionPool.

  Is invoked immediately after construction to provide the service and configuration context for this pool.

  Specified by:
    `initialize` in interface `ConnectionPool`
  Parameters:
    `service` - the S_LibraryService creating this ConnectionPool
    `configuration` - the ConnectionPool configuration parameters
  Throws:
    `IfsException` - (IFS-10620) if the operation fails
  (Unpublished)

### getConnectionPoolConfiguration

    public final ConnectionPoolConfiguration getConnectionPoolConfiguration()
                                                                     throws IfsException

  Description copied from class: `IfsConnectionPool`
  Gets the configuration parameters of this ConnectionPool.

  This method returns a copy of the configuration parameters for this ConnectionPool. To alter the configuration of this ConnectionPool, use the ConnectionPoolConfiguration mutators to adjust the values of these parameters and then call `setConnectionPoolConfiguration` to apply the altered ConnectionPoolConfiguration.

  The database URL, schema name, and schema password are not included in the returned parameters.

  Specified by:
    `getConnectionPoolConfiguration` in interface `ConnectionPool`
  Returns:
    the configuration
  Throws:
    `IfsException` - (IFS-10628) if the operation fails
  (Unpublished)

### setConnectionPoolConfiguration

    public final void setConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)
                                              throws IfsException

  Description copied from class: `IfsConnectionPool`
  Alters the configuration of this ConnectionPool.

  The following configuration parameters can be changed using this method:

  - Minimum size
  - Target size
  - Maximum size
  - Target size timeout
  - Maximum size timeout
  - Statement cache target
  - Statement cache size trigger

  All other configuration parameters specified in the ConnectionPoolConfiguration are ignored.

  Specified by:
    `setConnectionPoolConfiguration` in interface `ConnectionPool`
  Parameters:
    `configuration` - the configuration parameters
  Throws:
    `IfsException` - (IFS-10629) if the operation fails
  (Unpublished)

### acquireLibraryConnection

    public final LibraryConnection acquireLibraryConnection()
                                                     throws IfsException

  Description copied from class: `IfsConnectionPool`
  Gets a LibraryConnection from this ConnectionPool.

  Specified by:
    `acquireLibraryConnection` in interface `ConnectionPool`
  Returns:
    the connection
  Throws:
    `IfsException` - (IFS-10621) if the operation fails
  (Unpublished)

### createLibraryConnection

    protected final void createLibraryConnection()
                                          throws IfsException

  Description copied from class: `IfsConnectionPool`
  Creates a new LibraryConnection and adds it to this ConnectionPool.

  Throws:
    `IfsException` - (IFS-10633) if the operation fails
  (Unpublished)

### releaseLibraryConnection

    public final void releaseLibraryConnection(LibraryConnection lconn)
                                        throws IfsException

  Description copied from class: `IfsConnectionPool`
  Releases the specified LibraryConnection back to this ConnectionPool.

  Specified by:
    `releaseLibraryConnection` in interface `ConnectionPool`
  Parameters:
    `lconn` - the connection to release
  Throws:
    `IfsException` - (IFS-10622) if the operation fails
  (Unpublished)

### getConnectionPoolPerformance

    public final ConnectionPoolPerformance getConnectionPoolPerformance()
                                                                 throws IfsException

  Description copied from class: `IfsConnectionPool`
  Gets the performance information for this ConnectionPool.

  Specified by:
    `getConnectionPoolPerformance` in interface `ConnectionPool`
  Returns:
    a connection pool performance object
  Throws:
    `IfsException` - (IFS-10624) if the operation fails
  (Published)

### resetStatistics

    public final void resetStatistics()
                               throws IfsException

  Description copied from class: `IfsConnectionPool`
  Resets the performance statistics of this ConnectionPool.

  Specified by:
    `resetStatistics` in interface `ConnectionPool`
  Throws:
    `IfsException` - (IFS-10625) if the operation fails
  (Published)

### validateUnallocatedConnections

    public final void validateUnallocatedConnections()
                                              throws IfsException

  Description copied from class: `IfsConnectionPool`
  Validates the unallocated connections. Any connections that are invalid are disposed. This is called by the event exchanger when it has trouble getting or using a connection, which is usually a sign that many database connections might be invalid.

  Specified by:
    `validateUnallocatedConnections` in interface `ConnectionPool`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### dispose

    public final void dispose(boolean force)
                       throws IfsException

  Description copied from class: `IfsConnectionPool`
  Shuts down this ConnectionPool.

  Specified by:
    `dispose` in interface `ConnectionPool`
  Parameters:
    `force` - whether to perform a forced shutdown, closing in-use connections
  Throws:
    `IfsException` - (IFS-10626) if the operation fails
  (Unpublished)

### dispose

    public final void dispose()
                       throws IfsException

  Description copied from class: `IfsConnectionPool`
  Shuts down this ConnectionPool.

  Equivalent to `dispose(true)`.

  Specified by:
    `dispose` in interface `ConnectionPool`
  Specified by:
    `dispose` in interface `SubService`
  Throws:
    `IfsException` - (IFS-10626) if the operation fails
  (Unpublished)

### resetCachedStatements

    public final void resetCachedStatements()
                                     throws IfsException

  Description copied from class: `IfsConnectionPool`
  Resets the cached statements in all LibraryConnections.

  Specified by:
    `resetCachedStatements` in interface `ConnectionPool`
  Throws:
    `IfsException` - if the operation fails
  (Unpublished)

### validateConnectionPoolConfiguration

    protected void validateConnectionPoolConfiguration(ConnectionPoolConfiguration configuration)
                                                throws IfsException

  Description copied from class: `IfsConnectionPool`
  validate connection pool configuration. validates minimum size, target size, maximum size, target size timeout, maximum size timeout.

  Throws:
    `IfsException` - if the configuration is not valid
  (Unpublished)

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD